package signaturescheme

import "gitlab.imt-atlantique.fr/i18colle/goshimmer_without_tipselection/dapps/valuetransfers/packages/address"

// Signature defines an interface for an address signature generated by the corresponding signature scheme.
type Signature interface {
	// IsValid returns true if the signature is valid for the given data.
	IsValid(signedData []byte) bool

	// Bytes returns a marshaled version of the signature.
	Bytes() []byte

	// Address returns the address that this signature signs.
	Address() address.Address

	// PublicKeySize returns the size of the public key.
	PublicKeySize() int

	// SignatureSize returns the size of the signature.
	SignatureSize() int
}
